Page MenuHomeFreeBSD

ixgbe: fix software vlan handling
ClosedPublic

Authored by kp on Aug 11 2022, 1:16 PM.
Tags
None
Referenced Files
Unknown Object (File)
Mon, Feb 19, 4:47 PM
Unknown Object (File)
Thu, Feb 8, 9:52 AM
Unknown Object (File)
Jan 12 2024, 3:09 AM
Unknown Object (File)
Dec 20 2023, 7:29 AM
Unknown Object (File)
Dec 3 2023, 2:27 AM
Unknown Object (File)
Nov 14 2023, 1:24 PM
Unknown Object (File)
Nov 12 2023, 1:21 AM
Unknown Object (File)
Nov 9 2023, 3:32 AM
Subscribers

Details

Reviewers
None
Group Reviewers
network
pfsense
Intel Networking
Restricted Owners Package(Owns No Changed Paths)
Commits
rGe7abb897018b: ixgbe: fix software vlan handling
Summary

If hardware vlan tagging is disabled (after a vlan has been added) we
receive double-tagged packets, even if the packet on the wire only has a

single VLAN tag. That looks like this:

17:29:30.370787 00:51:82:11:22:02 > 90:ec:77:1f:8a:5f, ethertype 802.1Q (0x8100), length 64: vlan 0, p 0, ethertype 802.1Q, vlan 1001, p 0, ethertype ARP, Ethernet (len 6), IPv4 (len 4), Reply 10.101.0.12 is-at 00:51:82:11:22:02, length 42

This happens because the ixgbe driver does not clear the vlan flags in
the hardware (such as IXGBE_RXDCTL_VME) if IFCAP_VLAN_HWTAGGING is
cleared.

Add code to do so, which fixes this issue.

Sponsored by: Rubicon Communications, LLC ("Netgate")

Diff Detail

Repository
rS FreeBSD src repository - subversion
Lint
Lint Passed
Unit
No Test Coverage
Build Status
Buildable 46858
Build 43747: arc lint + arc unit

Event Timeline

kp requested review of this revision.Aug 11 2022, 1:16 PM
This revision was not accepted when it landed; it landed in state Needs Review.Aug 17 2022, 2:40 PM
This revision was automatically updated to reflect the committed changes.
Owners added a reviewer: Restricted Owners Package.Aug 17 2022, 2:40 PM